﻿using Hotline.Application.Snapshot;
using Hotline.Repository.SqlSugar.Extensions;
using Hotline.Share.Dtos;
using Hotline.Share.Dtos.Snapshot;
using Hotline.Share.Tools;
using Hotline.Snapshot;
using Hotline.Snapshot.Interfaces;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel;

namespace Hotline.Api.Controllers.Snapshot;

/// <summary>
/// 邀请码管理
/// </summary>
[Description("邀请码管理")]
public class InviteCodeController : BaseController
{
    private readonly IInviteCodeApplication _inviteCodeApplication;

    public InviteCodeController(IInviteCodeApplication inviteCodeApplication)
    {
        _inviteCodeApplication = inviteCodeApplication;
    }

    /// <summary>
    /// 获取邀请码集合
    /// </summary>
    /// <returns></returns>
    [HttpGet]
    public async Task<PagedDto<InviteCode>> GetInviteCodeItemsAsync([FromQuery]GetInviteCodeItemsInDto dto)
        => (await _inviteCodeApplication.GetInviteCodeItemsAsync().ToPagedListAsync(dto)).ToPaged();

    [HttpPost]
    public async Task AddInviteCodeAsync([FromBody] AddInviteCodeInDto dto)
        => await _inviteCodeApplication.AddInviteCodeAsync(dto);
}
