﻿using Hotline.Share.Dtos.Snapshot;
using Hotline.Snapshot;
using Hotline.Snapshot.Interfaces;
using Mapster;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Dependency;
using XF.Domain.Exceptions;

namespace Hotline.Application.Snapshot;
public class InviteCodeApplication : IInviteCodeApplication, IScopeDependency
{
    private readonly IInviteCodeRepository _inviteCodeRepository;

    public InviteCodeApplication(IInviteCodeRepository inviteCodeRepository)
    {
        _inviteCodeRepository = inviteCodeRepository;
    }

    public async Task AddInviteCodeAsync(AddInviteCodeInDto dto)
    {
        var entity = dto.Adapt<InviteCode>();
        if (dto.BeginCode >= dto.EndCode)
        {
            throw UserFriendlyException.SameMessage("开始邀请码不能大于结束邀请码");
        }
        await _inviteCodeRepository.AddAsync(entity);
    }

    public ISugarQueryable<InviteCode> GetInviteCodeItemsAsync()
    {
        return _inviteCodeRepository.Queryable();
    }
}
